/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function () {
dojo.provide("jazz.app.ThemableNode");

dojo.require("dijit._Widget");
dojo.require("jazz.client.xhr");
dojo.require("jazz.util.theming");

/*
 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
 * future with minimal or no warning.
 * 
 * @since 0.7
 */

dojo.declare("jazz.app.ThemableNode", [dijit._Widget], {
	constructor: function (args) {
		if (args && args.htmlPath && args.targetNode) {
			this.htmlPath = args.htmlPath;
			this.targetNode = args.targetNode;
			// only make requests for theming content if there is an active theme
			jazz.util.theming.jsDfd.addCallback(dojo.hitch(this, function () {
				var dfd = jazz.client.xhrGet({
					url: jazz.util.theming.themeFileUrl(this.htmlPath)
				});
				dfd.addCallback(dojo.hitch(this, this.handleContent));
				dfd.addErrback(dojo.hitch(this, this.handleErr));
			}));
		}
	},
	
	handleContent: function (content) {
		this.targetNode.innerHTML = content;
	},
	
	handleErr: function (error) {
		// Since not all theming styles will have custom content for a themable node,
		// we just ignore errors by default.  This method exists so users implementing
		// ThemableNode can connect to it in order to perform any custom error handling. 
	}
});
})();
