/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.dnd.OrderableList");

dojo.require("jazz.ui.dnd.DraggableContainer");
dojo.require("jazz.ui.dnd.DraggableManager");

(function() {
	var draggableManager = jazz.ui.dnd.draggableManager();
	
	/*
	 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
	 * future with minimal or no warning.
	 * 
	 * @since 0.7
	 */
	dojo.declare("jazz.ui.dnd.OrderableList", jazz.ui.dnd.DraggableContainer, {
		constructor: function(node, params) {
			this.avatarClass = "orderableListAvatar";
			this.nodes = params.nodes;
			dojo.addClass(this.node,"orderableList");
		},
		move: function(fromIndex, toContainer, toIndex) {
			var overWidget = draggableManager.overContainer.overWidget;
			if (overWidget) {
				var diff = this.getPlaceholder().index - overWidget.index;	
				for (var i = 0; i < this.nodes.length; i++) {
					if (this.nodes[i] == overWidget.domNode) {
						var destIndex = i;
					} else if (this.nodes[i] == draggableManager.fromContainer.widgets[fromIndex].domNode) {
						var initIndex = i;
					}
					if (destIndex && initIndex) {
						break;
					}
				}
				destIndex=destIndex+diff;
				if (draggableManager.overContainer != draggableManager.fromContainer && destIndex > initIndex) {
					destIndex--;
				}
			} else {
				diff = 0;
				for (var i = 0; i < this.nodes.length; i++) {
					if (this.nodes[i] == draggableManager.fromContainer.widgets[fromIndex].domNode) {
						var initIndex = i;
						break;
					}
				}
				var destIndex = 0;
			}
			this.nodes.splice(destIndex,0,this.nodes.splice(initIndex,1)[0]);
			this.updateIndices();
			if (draggableManager.fromContainer != draggableManager.overContainer) {
				this.updateIndices(draggableManager.fromContainer);
			}
			this.inherited(arguments);
		}
	});
})();
