/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.examples.TagCloudExamples");

/*
 * Imports 
 */
dojo.require("jazz.ui.TagCloud"); 


(function() {

/*
 * Aliases 
 */
var TagCloud = jazz.ui.TagCloud;

/*
 * Class 
 */
jazz.ui.examples.TagCloudExamples = {
	
	_tags1: [
		{
			name: "Mike Pawlowski", 
			value: 23
		},
		{
			name: "Curtis D'Entremont", 
			value: 4
		},
		{
			name: "Dejan Glozic", 
			value: 45
		},
		{
			name: "Rob Retchless", 
			value: 62
		},
		{
			name: "Robert Connell", 
			value: 112
		},
		{
			name: "Adam Archer", 
			value: 89
		},
		{
			name: "James Moody", 
			value: 72
		},
		{
			name: "Rafik Jaouni", 
			value: 5
		},
		{
			name: "Bill Higgins", 
			value: 124
		},
		{
			name: "Larry Smith", 
			value: 56
		},
		{
			name: "Patrick Streule", 
			value: 196
		},
		{
			name: "Erich Gamma", 
			value: 23
		},
		{
			name: "Kimberley Peter", 
			value: 73
		},
		{
			name: "Jennifer Hayes", 
			value: 90
		},
		{
			name: "Richard Backhouse", 
			value: 44
		},
		{
			name: "Linda Watson", 
			value: 79
		},
		{
			name: "Jim Des Rivieres", 
			value: 35
		},
		{
			name: "Kevin Haaland", 
			value: 151
		},
		{
			name: "James Stuckey", 
			value: 86
		},
		{
			name: "Matt Jarvis", 
			value: 63
		}
	],

	_tags2: [
		{
			name: "Major", 
			value: 53
		},
		{
			name: "Minor", 
			value: 27
		},
		{
			name: "Critical", 
			value: 15
		},
		{
			name: "Blocker", 
			value: 10
		},
		{
			name: "Unclassified", 
			value: 44
		},
		{
			name: "Normal", 
			value: 150
		}
	],

	_tags3: [
		{
			name: "High", 
			value: 10
		},
		{
			name: "Medium", 
			value: 10
		},
		{
			name: "Low", 
			value: 10
		},
		{
			name: "Unassigned", 
			value: 10
		}
	],


	/*
 	 * Private Method
 	 * 
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud1: function() {
		
		var widget = new TagCloud({
						 tags: this._tags1,
						 viewableTagLimit: 10,
						 showFrequencies: true,
						 hrefProvider: this._handleEventGetLink
					});
		
		return widget;
	},

	/*
 	 * Private Method
 	 * 
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud2: function() {
		
		var widget = new TagCloud({
						 tags: this._tags1,
						 onTagClick: this._handleEventTagClick
					});
		
		return widget;
	},

	/*
 	 * Private Method
 	 * 
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud3: function() {
		
		var widget = new TagCloud({
						 tags: this._tags2,
						 showFrequencies: false,
						 onTagClick: this._handleEventTagClick
					});
		
		return widget;
	},

	/*
 	 * Private Method
 	 * 
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud4: function() {
		
		var widget = new TagCloud({
						 tags: this._tags3,
						 showFrequencies: true,
						 onTagClick: this._handleEventTagClick
					});
		
		return widget;
	},

	/*
 	 * Private Method
 	 * 
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud5: function() {
		
		var tags = [];
		
		for (var index = 0; index < 100; index++) {
			tags[index] = {
				name: index + 1 + 100,
				value: index + 1 + 100
			};
		}
		
		var widget = new TagCloud({
						 tags: tags,
						 showFrequencies: true,
						 onTagClick: this._handleEventTagClick
					});
		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud6: function() {
		
		var widget = new TagCloud({
						 tags: this._tags1,
						 viewableTagLimit: 10,
						 showFrequencies: true
					});
		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud7: function() {
		
		var widget = new TagCloud({
						 tags: this._tags1
					});
		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud8: function() {
		
		var widget = new TagCloud({
						 tags: this._tags2,
						 showFrequencies: false
					});
		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud9: function() {
		
		var widget = new TagCloud({
						 tags: this._tags3,
						 showFrequencies: true
					});
		
		return widget;
	},

	/*
 	 * @param void
 	 * 
 	 * @return TagCloud
 	 */		
	_createTagCloud10: function() {
		
		var tags = [];
		
		for (var index = 0; index < 100; index++) {
			tags[index] = {
				name: index + 1 + 100,
				value: index + 1 + 100
			};
		}
		
		var widget = new TagCloud({
						 tags: tags,
						 showFrequencies: true
					});
		
		return widget;
	},

	/*
 	 * Private Method
 	 * 
 	 * @param TagCloud tagCloud
 	 * @param String tagName
 	 * 
 	 * @return String
 	 */		
	_handleEventGetLink: function(tagCloud, tagName) {
		
		var firstName = tagName.split(" ", 2)[0].toLowerCase();
 		var url = "http://www.behindthename.com/name/" + firstName;
		
		return url;
	},

	/*
 	 * Private Method
 	 * 
 	 * @param TagCloud tagCloud
 	 * @param String tagName
 	 * 
 	 * @return void
 	 */		
	_handleEventTagClick: function(tagCloud, tagName) {
		var tagValue = tagCloud.getTagValue(tagName);
		alert("Name: " + tagName + "\nValue: " + tagValue);
	},

	/*
 	 * Public Method
 	 * 
 	 * @param void
 	 * 
 	 * @return Element
 	 */		
	_createContainer: function() {
		var container = document.createElement("div");
		container.style.width = "400px";
		container.style.border = "1px solid black";
		container.style.margin = "3px";
		return container;
	},

	/*
 	 * Public Method
 	 * 
 	 * @param Element parent
 	 * 
 	 * @return void
 	 */		
	create: function(parent) {
		
		var table = document.createElement("table");
		var tbody = document.createElement("tbody");
		var tr = document.createElement("tr");
		var td1 = document.createElement("td");
		var td2 = document.createElement("td");
		
		// Example 1
		var container1 = this._createContainer();
		this._tagCloud1 = this._createTagCloud1();
		container1.appendChild(this._tagCloud1.domNode);

		// Example 2
		var container2 = this._createContainer();
		this._tagCloud2 = this._createTagCloud2();
		container2.appendChild(this._tagCloud2.domNode);
		
		// Example 3
		var container3 = this._createContainer();
		this._tagCloud3 = this._createTagCloud3();
		container3.appendChild(this._tagCloud3.domNode);

		// Example 4
		var container4 = this._createContainer();
		this._tagCloud4 = this._createTagCloud4();
		container4.appendChild(this._tagCloud4.domNode);

		// Example 5
		var container5 = this._createContainer();
		this._tagCloud5 = this._createTagCloud5();
		container5.appendChild(this._tagCloud5.domNode);

		// Example 6
		var container6 = this._createContainer();
		this._tagCloud6 = this._createTagCloud6();
		container6.appendChild(this._tagCloud6.domNode);

		// Example 7
		var container7 = this._createContainer();
		this._tagCloud7 = this._createTagCloud7();
		container7.appendChild(this._tagCloud7.domNode);

		// Example 8
		var container8 = this._createContainer();
		this._tagCloud8 = this._createTagCloud8();
		container8.appendChild(this._tagCloud8.domNode);

		// Example 9
		var container9 = this._createContainer();
		this._tagCloud9 = this._createTagCloud9();
		container9.appendChild(this._tagCloud9.domNode);

		// Example 10
		var container10 = this._createContainer();
		this._tagCloud10 = this._createTagCloud10();
		container10.appendChild(this._tagCloud10.domNode);

		// Assemble contents

		td1.appendChild(container1);
		td1.appendChild(container2);
		td1.appendChild(container3);
		td1.appendChild(container4);
		td1.appendChild(container5);

		td2.appendChild(container6);
		td2.appendChild(container7);
		td2.appendChild(container8);
		td2.appendChild(container9);
		td2.appendChild(container10);

		
		tr.appendChild(td1);
		tr.appendChild(td2);
		tbody.appendChild(tr);
		table.appendChild(tbody);
		parent.appendChild(table);
	}

};


})();

