/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.LicenseWizard");
    
    dojo.require("dojo.date");
    dojo.require("dojo.date.locale");
    dojo.require("dojo.date.stamp");
    dojo.require("dojo.number");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dojox.data.dom");
    
    dojo.require("jazz.ui.HoverPopup");
    dojo.require("net.jazz.ajax.ui.PlatformUI");
    
    dojo.require("com.ibm.team.repository.web.client.internal.licensing");
	dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.FileUploader");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.ConfigUtility");
    dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
    dojo.require("com.ibm.team.repository.web.ui.internal.Util");
    dojo.require("dojo.i18n");
    
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseHelper");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseQuickConnectStep");
	dojo.require("com.ibm.team.repository.web.ui.wizard.WizardStep");
    dojo.require("com.ibm.team.repository.web.ui.wizard.WizardStepHeader");
    
    
    //
    // Aliases
    //
    
    var FileUploader = com.ibm.team.repository.web.ui.internal.admin.server.FileUploader;
	var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
    var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
    var LIC_P = com.ibm.team.repository.web.client.internal.licensing;
    var formatCALTypeDescription = LIC_P.formatCALTypeDescription;
    var getLicenseInfo = LIC_P.getLicenseInfo;
    var getUsedLicenseInfo = LIC_P.getUsedLicenseInfo;
    var getExpirationInfo = LIC_P.getExpirationInfo;
    var sortCALs = LIC_P.sortCALs;
    var HoverPopup = jazz.ui.HoverPopup;
    var postLicenseInfo = LIC_P.postLicenseInfo;
    var removeChildren = dojox.data.dom.removeChildren;
    var SRH = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var UPLOAD_URI = LIC_P.FILE_UPLOAD_URI;
    var FLOATING_LICENSE_SERVICE_NAME = "com.ibm.team.repository.service.internal.license.LicenseService";
    var FLOATING_SUPPORT_OPERATION_ID = "com.ibm.team.repository.support.floatingLicenses";
    var LicenseHelper = com.ibm.team.repository.web.ui.internal.admin.server.LicenseHelper;
	var LicenseQuickConnectStep = com.ibm.team.repository.web.ui.internal.admin.server.LicenseQuickConnectStep;
    var WizardStepHeader = com.ibm.team.repository.web.ui.wizard.WizardStepHeader;
    var WizardStep = com.ibm.team.repository.web.ui.wizard.WizardStep;
    var STATUS_TYPES = com.ibm.team.repository.web.ui.wizard.WizardStepHeader.STATUS_TYPES;
    var ConfigUtility = com.ibm.team.repository.web.ui.internal.admin.server.ConfigUtility;
	var DEFAULT_LICENSE_SERVICE = "com.ibm.team.repository.service.internal.license.DefaultLicenseProviderService";
    
    var messages;
    //
    // Widget definition
    //
    
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.LicenseWizard", [WizardStep, LicenseHelper, dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/server/templates/LicenseWizard.html"),
        
        constructor: function(){
            this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseEditorMessages");
        },
        
        postCreate: function(){
            com.ibm.team.repository.web.ui.internal.admin.server.LicenseWizard.superclass.postCreate.apply(this);
            
            this._setInfopopHeading(this.limitHeader, "limitHeader", "limitHeaderInfo");
            this._setInfopopHeading(this.includedHeader, "includedHeader", "includedHeaderInfo");
            this._setInfopopHeading(this.totalHeader, "totalHeader", "totalHeaderInfo");
            this._setInfopopHeading(this.previewUsersHeader, "usersHeader", "usersHeaderInfo");
            this._setInfopopHeading(this.assignedHeader, "assignedHeader", "assignedHeaderInfo");
            this._setInfopopHeading(this.availableHeader, "availableHeader", "availableHeaderInfo");
            
            this.header = new WizardStepHeader({
                stepTitle: this.stepTitle
            });
            this.stepHeaderArea.appendChild(this.header.domNode);
            
            this.configUtil = new ConfigUtility();
            
            this.maxCounts = [];
            this.newUploads = new Array();
            
            this.initialLicenseInfo = this.licenseInfo;
            
            if (this.mode == "upload") {
                this.uploadMode.style.display = "block";
                this.reset(this.licenseInfo);
                this.loadForms();
            }
			else if(this.mode == "setDefault") {
				this.setDefaultMode.style.display = "block";
				this.connect(this.licensePicker,"onchange","triggerButtonStateUpdate");
                this.loadDefault();
			}
            else {
                this.editCountMode.style.display = "block";
                this.loadCALTable();
            }
        },
		
		loadDefault: function() {	
			if(!this.defaultLicense) {
				//No idea what the default was, don't load wizard.
				return;
			} 
			else {
				
				var self = this;
	            var types = this.licenseInfo.types || [];
	            types = sortCALs(types);
	
				//Create a default entry for "none".
				var item = document.createElement("option");
				item.value = "";
				item.innerHTML = this.messages.noDefault;
				this.licensePicker.appendChild(item);
				
				this.defaultLicenseDescription.innerHTML = this.defaultLicense.description;
	
				//Loop the current license keys and add as options
	            dojo.forEach(types, function(type){			
					var item = document.createElement("option");
					if(type.id == self.defaultLicense.overrideValue) {
						item.selected = true;
					}	
					item.value = type.id;
					item.innerHTML = type.productName + " " + type.name + " (" + type.variantName + ")";
					self.licensePicker.appendChild(item);
				});		
			}				
		},
		
		hasDefaultChanged: function () {
			if (this.defaultLicense && this.defaultLicense.overrideValue) {
			return this.defaultLicense.overrideValue != this.licensePicker.value;
			} else {
				return this.licensePicker.value.length > 0;
			}
		},
		
		saveDefaultLicense: function() {
			var changes = [{
                "name":"default.licenseid",
				"value":this.licensePicker.value,
				"serviceImplementationName": DEFAULT_LICENSE_SERVICE
            }];
          
            var changeList = {
                "changes": changes,
                "properties": []
            };
			
			this.configUtil.save(changeList, this, "cbSave", "cbSaveError");
		},
        
        loadCALTable: function(){
            var tbody = this.EditCALTable;
            var self = this;
            removeChildren(tbody);
            
            if (this.floatingOn) {
                var types = this.licenseInfo.floatingLicenseTypes || [];
            }
            else {
                var types = this.licenseInfo.types || [];
            }
            types = sortCALs(types);
            
            var isTrial = this.licenseInfo.serverLicense.expirationTime ? true : false;
            this._setPurchasesOrTrialTableHeader(this.purchasedOrTrialHeader);
            
            dojo.forEach(types, function(type){
                //Use this check to prevent aquired floating CALs to show in edit view
                if (self.floatingOn || type.floating == false) {
                            
                
                    var icon = d.ce("div");
                    var status = d.ce("span");
                    
                    var row = d.ce("tr");
                    tbody.appendChild(row);
                    
                    var nameLink = self._getInfopopLink(type.name, formatCALTypeDescription(type));
                    var isDisabled = type.disabledReason != null;
                    
                    if (isDisabled) {
                        row.className = "disabledCAL";
                        icon.className = "icon-error";
                        dojo.addClass(nameLink, "disabledCAL");
                        status.innerHTML = dojo.string.substitute(self.messages.deactivatedReason, [type.disabledReason]);
                        dojo.addClass(status, "WARNINGcolor");
                    }
                    else {
                        icon.className = "icon-ok";
                        status.innerHTML = self.messages.activated;
                    }
                    
                    var limit = getCountOrUnlimited(type.max);
                    var included = getCountOrUnlimited(type.free);
                    var total = getCountOrUnlimited(type.total);
                    
                    if (isTrial && type.floating == false) {
                        var available = type.max === -1 ? self.messages.unlimited : type.max - type.used;
                        var purchase = type.max === -1 ? self.messages.notApplicable : type.max - type.free;
                        var total = getCountOrUnlimited(type.max);
                    }
                    else {
                        var available = type.total === -1 ? self.messages.unlimited : type.total - type.used;
                        var purchase = type.free === -1 ? self.messages.notApplicable : type.total - type.free;
                    }
                    
                    var nodes = [type.productName, type.editionName + " (" + type.variantName + ")", nameLink, limit, included, purchasedOrTrialCol(self, type, isTrial, purchase, type.floating), total, getUsedLink(type), available, icon, status , type.version];
                    
                    dojo.forEach(nodes, function(node){
                        col(row, node);
                    });
                    
                } // end floating check
            });
            
        },
        
        saveEditor: function() {
			this.header.showStatus({
                type: STATUS_TYPES.INFO,
                summary: this.messages.savingLicenseInfo
            });
            var args = dojo.mixin(this.getEditorData(), {
                commit: true
            });
            postLicenseInfo(new SRH(this, "cbSave", "cbSaveError"), args);
        },
		
		getFloatingURL: function(data) {
			var url;
			if(this.step2.checkboxFloatingServer.checked == true) {
				dojo.forEach(data.properties,function(property) {
					if(property.name == "server.repourl.port.http") {
						
						var port = property.overrideValue || property.defaultValue;
						var contextRoot = net.jazz.ajax._contextRoot;
						url = "http://localhost:" + port + contextRoot;
					}
				});
			} else {
				url = "";
			}
			
			var changes = [{
                "name": "licenseService.floatingLicenseServerURI",
                "serviceImplementationName": "com.ibm.team.repository.service.internal.license.LicenseService",
                "value": url
            }];
            
            var changeList = {
                "changes": changes,
                "properties": []
            };
            this.configUtil.save(changeList, this, "saveEditor", "cbSaveError");
				
		},
        
        /**
         * Success callback from 'Save' action; resets editor based on newly
         * persisted state.
         */
        cbSave: function(licenseInfo){
			if(licenseInfo) {
				this.reset(licenseInfo);
				dojo.publish(com.ibm.team.repository.web.internal.events.licenseChange, [licenseInfo]);	
			}
            this.parentPointer.reload();
            var self = this;
            function f(){
                self.header.clearMessages();
				self.parentPointer.wizard.contentArgs.container.close();
            }
            this.showEventOutcomeMessage("ok", this.messages.saveComplete, f, 1500);     
       },
        
        cbSaveError: function(errObj){
            this.cbRemoteError(errObj, this.messages.saveError);
        },
        //
        // Upload-related methods
        //
        
        cbUpload: function(obj, widgetPropName){
            this.markDirtyLicenseInfo();
            this.lastUploadType = obj;
			//If the object is a batch of keys (ZIP), batch process them 
			if(obj.licenses) {
				var self = this;
				dojo.forEach(obj.licenses,function(item) {
					self._uploadedCALFiles[item.policy.id] = item.fileName; //**do we need this? or is it just 1 file?? ***
					if (dojo.indexOf(self.newUploads, item.policy.id) == -1) {
						self.newUploads.push(item.policy.id);
					}
				});
				
			} else {
				//This is a single CAL in a JAR file. Process normally.	
	            this._uploadedCALFiles[obj.policy.id] = obj.fileName;
	            if (dojo.indexOf(this.newUploads, obj.policy.id) == -1) {
	                this.newUploads.push(obj.policy.id);
	            }
			}
            this.showEventOutcomeMessage("ok", this.messages.successfulUpload, dojo.hitch(this, this.fetchToBeState), 1000);
        },
        
        cbUploadFailure: function(errObj){
            this.header.showStatus({
                type: STATUS_TYPES.ERROR,
                summary: this.messages.errorUpload + errObj.errorMessage
            });
        },
        
        deletePreviewEntry: function(e){
	
            var verifyDelete = confirm(this.messages.confirmDelete);
            if (verifyDelete) {
				var loc = e.target;
                var index = dojo.indexOf(this.newUploads, loc.id);
                if (index != -1) {
                    this.newUploads.splice(index, 1);
					//We need to remove the additional steps if the last uploaded key was deleted
					if(!this.lastUploadType.licenses && this.lastUploadType.policy.id == loc.id ) {
						this.editCountBox.style.display = "none";
					}
					//Remove the uploaded file from the array
					if (this._uploadedCALFiles[loc.id]) {
						delete this._uploadedCALFiles[loc.id];
					}
					//also discard any changes that may have been made in these steps
					if (this.maxCounts[loc.id]) {
						delete this.maxCounts[loc.id];
					}
					this.buildPreviewTable();
                }
            }
        },
        
        showUploadPreview: function(){
        
            this.header.clearMessages();
            this.setPreviewMessage("", "noDisplay");
            this.editCountBox.style.display = "none";
            this.buildPreviewTable();
        },
        
        buildPreviewTable: function(){
        
            removeChildren(this.uploadQueue);
            var self = this;
            dojo.forEach(this.newUploads, function(licId){
                //Lookup the object that relates to this id.
                var licInfo, licType;
                //First see if it is a server key.. easy case
                if (self.licenseInfo.serverLicense.id == licId) {
                    licInfo = self.licenseInfo.serverLicense;
                    licType = "sever";
                }
                else {
                    //Have to handle types array separately to filter out floating keys
                    var types = self.licenseInfo.types || [];
                    dojo.forEach(types, function(t){
                    
                        if (!t.floating && t.id == licId) {
                            licInfo = t;
                            licType = "CAL";
                        }
                    });
                    //Only traverse floatingTypes if we haven't found the key yet
                    if (licInfo == null || licType == null) {
                        var floatingTypes = self.licenseInfo.floatingLicenseTypes || [];
                        dojo.forEach(floatingTypes, function(t){
                            if (t.id == licId) {
                                licInfo = t;
                                licType = "CAL";
                            }
                        });
                    }
                }
                
                //If we don't have enough information to build this row. Skip it.
                if (licInfo != null && licType != null) {
                
                    var icon = d.ce("div");
                    var status = d.ce("span");
                    var row = d.ce("tr");
                    self.uploadQueue.appendChild(row);
                    icon.className = "icon-ok";
                    var isDisabled = licInfo.disabledReason != null;
                    if (isDisabled) {
                        row.className = "disabledCAL";
                        icon.className = "icon-error";
                        dojo.addClass(status, "WARNINGcolor");
                    }
                    
                    var total = d.ce("div");
                    total.setAttribute('id', "total-" + licInfo.id);
                    row.setAttribute('id', "row-" + licInfo.id)
                    
                    //Build delete button
                    var del = d.ce("img");
                    var removeIconSrc = dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/users/images/remove.gif");
                    del.setAttribute('src', removeIconSrc);
                    del.setAttribute('title', self.messages.removeKey);
                    del.setAttribute('id', licInfo.id);
                    del.setAttribute('style', "cursor:pointer;");
                    dojo.connect(del,"onclick",self, "deletePreviewEntry");
                    
                    if (licType == "CAL") {
                        var nameLink = self._getInfopopLink(licInfo.name, formatCALTypeDescription(licInfo));
                        if (isDisabled) 
                            dojo.addClass(nameLink, "disabledCAL");
                        var serverLicense = self.licenseInfo.serverLicense;
                        var isTrial = serverLicense.expirationTime ? true : false;
                        status.innerHTML = isDisabled ? dojo.string.substitute(self.messages.deactivatedReason, [licInfo.disabledReason]) : self.messages.activated;
                        
                        if (self.maxCounts[licInfo.id]) {
                            total.innerHTML = self.maxCounts[licInfo.id] + licInfo.free;
                        }
                        else {
                            total.innerHTML = isTrial ? getCountOrUnlimited(licInfo.max) : getCountOrUnlimited(licInfo.total);
                        }
                        var nodes = [licInfo.productName, licInfo.editionName + " (" + licInfo.variantName + ")", nameLink, total, icon, status, del , licInfo.version];
                        
                    }
                    else {
                        total.innerHTML = licInfo.maxContributors !== -1 ? licInfo.maxContributors : self.messages.unlimited;
                        var editionLabel = licInfo.editionName ? licInfo.editionName : "";
                        editionLabel += licInfo.variantName ? " (" + licInfo.variantName + ")" : "";
                        var isTrial = licInfo.expirationTime ? true : false;
                        if (isTrial) {
                            var expirationInfo = getExpirationInfo(licInfo.expirationTime);
                        }
                        if (licInfo.disabledReason) {
                            status.innerHTML = licInfo.disabledReason;
                        }
                        else {
                            status.innerHTML = !isTrial ? self.messages.permanent : expirationInfo.isExpired ? self.messages.expiredTrial : self.messages.trial;
                        }
                        var nodes = [licInfo.productName, editionLabel, "Server Key", total, icon, status, del];
                        
                    } //endif - licType=='CAL' check
                    dojo.forEach(nodes, function(node){
                        col(row, node);
                    });
                    
                } //endif - only build row if we have licInfo != null
            });
            
        },
        
        highlightNode: function(node){
            var fx = dojo.animateProperty({
                node: node,
                duration: 1000,
                properties: {
                    backgroundColor: {
                        start: "#FF7",
                        end: "#FFF"
                    }
                }
            });
            fx.play();
        },
        
        connectToMyself: function(){
			//Dont bother adding a step if it already exists.
			var self = this;
			var numSteps = this.parentPointer.wizard.contentWidget._steps.length;
			if (numSteps == 1 && this.parentPointer.licenseInfo.floatingSetupStatus) {
                var url = this.parentPointer.licenseInfo.floatingSetupStatus.serverURL;
				var val = (url && url != "") ? true : false;
				var self = this;
	            this.step2 = new LicenseQuickConnectStep({
					stepTitle: this.messages.step2Title,
					initialVal: val
	            });
				this.parentPointer.wizard.contentWidget.showStepList();	
				this.parentPointer.wizard.addStep(this.step2);	
			}
            
        },
						
		saveFloatingConnection: function(){
			this.header.showStatus({
                type: STATUS_TYPES.INFO,
                summary: this.messages.savingLicenseInfo
            });
			var handler = new SRH(this,"getFloatingURL","cbSaveError");
			var serviceName = "com.ibm.team.repository.service.internal.webuiInitializer.ConfigPropertyInitializer";
			ServerStatusClient.getServiceConfiguration(handler,serviceName);     
        },
		    
        updatePurchaseCounts: function(){
            var errors = [];
            var types = this.licenseInfo.types || [];
            var floatingTypes = this.licenseInfo.floatingLicenseTypes || [];
            var combined = types.concat(floatingTypes);
            var isTrial = this.licenseInfo.serverLicense.expirationTime ? true : false;
            var self = this;
            var type;
            dojo.forEach(combined, function(t){
                if (t.name == self.lastUploadType.policy.name) {
                    type = t;
                }
            });

            var limit = getCountOrUnlimited(type.max);
            var included = getCountOrUnlimited(type.free);
            
            if (isTrial && type.floating == false) {
                var purchase = type.max === -1 ? self.messages.notApplicable : type.max - type.free;
            }
            else {
                var purchase = type.free === -1 ? self.messages.notApplicable : type.total - type.free;
            }
            
            // Remove the existing input box from previous CAL if necessary
            var input = dojo.byId('inputCalCount');
            if (input != null) 
                removeChildren(this.purchaseCounts);
            
            // Display input box for user to enter # of purchased CALs
            var elem = purchasedOrTrialCol(self, type, isTrial, purchase, /*isFloating */ type.floating);
            //Only show input box if purchase count is editable
            if (elem[0].tagName == "INPUT") {
            
                if (this.maxCounts[type.id]) {
                    this.totalCount.innerHTML = this.maxCounts[type.id] + type.free;
                }
                else {
                    this.totalCount.innerHTML = isTrial ? getCountOrUnlimited(type.max) : getCountOrUnlimited(type.total);
                }
                
                this.includedCount.innerHTML = included;
                this.purchaseCounts.appendChild(elem[0]);
                this.purchaseCounts.appendChild(elem[1]);
                this.editCountBox.style.display = "block";
                //Highlight the column these settings apply to.
                var row = dojo.byId("row-" + type.id);
                if (row) dojo.addClass(row.childNodes[3], "selected");              
            }
            
            return errors;
        },
        
        onPurchasedCountKeyUp: function(e){
            var input = e.target;
            if (!input || input.__jazzOrigValue === undefined) {
                return; // early return
            }
            if (input.value !== input.__jazzOrigValue) {
                this.markDirtyLicenseInfo();
            }
            // Run a validation after the user stops typing for half a second
            if (this._calKeyStrokeTimout) {
                clearTimeout(this._calKeyStrokeTimout);
            }
            this._calKeyStrokeTimout = setTimeout(dojo.hitch(this, this.validate), 500);
        },
        
        // Utility methods
        //
        
        /**
         * General purpose error callback for remote methods.
         */
        cbRemoteError: function(errorObj, msg){
            if (!msg) {
                msg = this.messages.serverError;
            }
            if (errorObj.status === 0) {
                msg += this.messages.serverUnreachable;
            }
            else {
                msg += " (" + errorObj.message + ")";
            }
            this.showEventOutcomeMessage("error", msg);
        },
        
        
        /**
         * Resets both the object and UI state of this editor, based on the
         * <code>licenseInfo</code> parameter (short-op).
         */
        reset: function(licenseInfo){
            // reset object state
            this.initialLicenseInfo = this.licenseInfo = licenseInfo;
            this.usedLicenseInfo = null;
            this._uploadedCALFiles = [];
            this.lastFloatingCount = licenseInfo.floatingLicenseTypes && licenseInfo.floatingLicenseTypes.length ? licenseInfo.floatingLicenseTypes.length : 0;
            this.isDirtyLicenseInfo = false;
            
            // reset UI state
            this.header.clearMessages();
            this.checkDirty();
            
            this.setPreviewMessage("", "noDisplay");
            var self = this;
            var floatHelper = {
                yes: function(status){
                    //	self.addLicenseUsageDetails();
                },
                no: function(s){
                    self.usedLicenseInfo = null;
                },
                error: function(err){
                    self.cbRemoteError(err);
                }
            }
            
            LIC_P.checkFloatingLicensesSupported(floatHelper.yes, floatHelper.no, floatHelper.error);
        },
        
        
        /**
         * Fetches the most recent saved license information from the server and
         * resets the editor with this information (long-op).
         */
        reload: function(){
            if (this._isDirty && !confirm(this.messages.refreshDirty)) {
                return;
            }
            var self = this;
            var o = {
                s: function(licenseInfo){
                
                    self.reset(licenseInfo);
                    self.initialLicenseInfo = self.licenseInfo = licenseInfo;
                    
                    // reset UI state
                    self.header.clearMessages();
                    self.checkDirty();
                },
                f: function(err){
                    self.cbRemoteError(err);
                }
            }
            getLicenseInfo(new SRH(o, "s", "f"));
        },
        updateLicenseInfo: function(){
            var self = this;
            var o = {
                s: function(licenseInfo){
                    self.initialLicenseInfo = self.licenseInfo = licenseInfo;
                },
                f: function(err){
                    self.cbRemoteError(err);
                }
            }
            getLicenseInfo(new SRH(o, "s", "f"));
        },
        
        
        //
        // UI Status and State reporting
        //
        
        showEventOutcomeMessage: function(type, message, cb, duration){
            if (cb) {
                setTimeout(cb, duration || 3000);
            }
            else 
                if (duration) {
                    setTimeout(function(){
                        this.header.clearMessages()
                    }, duration);
                }
            var t = STATUS_TYPES.INFO;
            if (type == "error") 
                t = STATUS_TYPES.ERROR;
            this.header.showStatus({
                type: t,
                summary: message
            });
        },
        
        updateStatusMessage: function(){
			var hasErrors = this.status.errors.length > 0;
            var hasWarnings = this.status.warnings.length > 0;
            var hasPendingAction = this.status.pending.length > 0;
			if (hasErrors || hasWarnings) {
                if (hasErrors) {
                    var numErrors = this.status.errors.length;
					if(numErrors && numErrors > 1) {
						//Break up multiple messages
						var errDetails = [];
						for (var i = 0; i < this.status.errors.length; i++) {
							warnDetails.push({message: this.status.errors[i], code: STATUS_TYPES.ERROR});
						}
						this.header.showStatus({
	                        type: STATUS_TYPES.ERROR,
	                        summary: dojo.string.substitute(this.messages.multipleErrors, [numErrors]),
							details: errDetails
	                    });
					} else {
						this.header.showStatus({
	                        type: STATUS_TYPES.ERROR,
	                        summary: this.status.errors
	                    });					
					}			
				//hasWarnings
                } else {	
					var numWarnings = this.status.warnings.length;
					if(numWarnings > 1) {
						//Break up multiple messages
						var warnDetails = [];
						for (var i = 0; i < this.status.warnings.length; i++) {
							warnDetails.push({message: this.status.warnings[i], code: STATUS_TYPES.WARNING});
						}
						this.header.showStatus({
	                        type: STATUS_TYPES.WARNING,
	                        summary: dojo.string.substitute(messages.multipleWarnings, [numWarnings]),
							details: warnDetails
	                    });
					} else {
						this.header.showStatus({
	                        type: STATUS_TYPES.WARNING,
	                        summary: this.status.warnings
	                    });
					}

                }
            }
            else 
                if (this._isDirty) {
                
                    if (hasPendingAction) {
                        this.header.showStatus({
                            type: STATUS_TYPES.INFO,
                            summary: this.status.pending
                        });
                    }
                    else {
                        var pendingMsg = this.mode == "upload" ? this.messages.pendingChangesInfo : this.messages.pendingChangesEditMode;
                        this.header.showStatus({
                            type: STATUS_TYPES.INFO,
                            summary: pendingMsg
                        });
                    }
                    
                }
                else {
                    this.header.clearMessages();
                }
        },
        
        //
        // UI data binding and querying
        //
        
        loadForms: function(){
            var formName1 = "newCALUploadForm";
            this[formName1] = this.createForm("unknown", formName1);
            this._uploadedCALFiles = [];
        },
        
        createForm: function(typeCode, formName){
            var self = this;
            var args = {
                formElements: [{
                    name: "licenseType",
                    value: typeCode
                }],
                formLabel: self.messages.uploadFormLabel,
                onBeginUpload: function(){
                    self.header.showStatus({
                        type: STATUS_TYPES.INFO,
                        summary: self.messages.uploadingFile
                    });
                },
                onUpload: function(o){
                    self.cbUpload(o, formName);
                },
                onUploadFailure: function(errObj){
                    self.cbUploadFailure(errObj);
                },
                postURI: UPLOAD_URI
            }
            return new FileUploader(args, this[formName]);
        },
        
        /**
         * Validate does the following:
         *
         * 1) Compares the state of the CALs in the dirty editor vs. the CALs'
         *    original state. The purpose of this validation is to generate warnings
         *    if the user is about to disable users that were previously enabled.
         * 2) Ensures that editable CAL 'purchased' counts are >= 0 and less than
         *    the maximum purchasable count for the CAL.
         *
         * 3) Validates the License Server Configuration property value.
         */
        validate: function(){
            var warnings = this.validateCALStates();
            warnings = warnings.concat(this.validateFloatingLicenseChanges());
            
            var errors = this.validateServerLicense();
            errors = errors.concat(this.validateCALPurchaseCounts());

            // CAL purchase counts can have errors, 
            // CAL state changes can produce warnings,
            // Server License Configuration can produce errors or warnings.
            this.status = {
                errors: errors,
                warnings: warnings,
                pending: []
            };
            
            
            this.triggerButtonStateUpdate();
            this.updateStatusMessage();
        },
        
        validateFloatingLicenseChanges: function(){
            var floatingIssues = false;
            var supportsFloating = findOperationCheckResults(this.licenseInfo, FLOATING_SUPPORT_OPERATION_ID);
            
            if (this.usedLicenseInfo && this.usedLicenseInfo.activeLeases) {
                var numActiveLeases = this.usedLicenseInfo.activeLeases.length;
                if (numActiveLeases > 0) {
                    if (!supportsFloating) {
                        floatingIssues = true;
                    }
                }
            }
            
            if (this.usedLicenseInfo && this.initialLicenseInfo.floatingLicenseTypes) {
                var numInstalledFloatingCALs = this.initialLicenseInfo.floatingLicenseTypes.length;
                if (numInstalledFloatingCALs > 0) {
                    if (!supportsFloating) {
                        floatingIssues = true;
                    }
                }
            }
            
            var warnings = [];
            
            if (!supportsFloating && this.lastUploadType.keyType == "server") {
                //If the user just uploaded a server license that no longer supports floating lic files...
                this.setPreviewMessage(this.messages.noFloatSupport, "previewMessage");
            }
            
            if (floatingIssues) {
                warnings.push(this.messages.noFloatMismatch);
            }
            if (this.lastFloatingCount === 0 && this.licenseInfo.floatingLicenseTypes && this.licenseInfo.floatingLicenseTypes.length > 0) {
                warnings.push(this.messages.convertToFloatingWarning);
            }
            
            return warnings;
        },
        
        validateCALStates: function(){
            var warnings = [];
            var origGood = {};
            var origTypes = this.initialLicenseInfo.types;
            dojo.forEach(origTypes, function(type){
                if (!type.disabledReason) {
                    origGood[type.id] = true;
                }
            });
            var dirtyTypes = this.licenseInfo.types;
            var self = this;
            dojo.forEach(dirtyTypes, function(type){
                if (type.disabledReason && origGood[type.id]) {
                    warnings.push(dojo.string.substitute(self.messages.pendingCalDeactivation, [type.name]));
                }
            });
            return warnings;
        },
        
        validateCALPurchaseCounts: function(){
            var errors = [];
            
            if (this.mode == "upload") {
            
                //Upload mode	
                var input = dojo.byId('inputCalCount');
                if (input && input.tagName == "INPUT") {
                    var result = validateCALInput(input);
                    if (!result.valid) {
                        errors = [this.messages.purchaseCountError];
                    }
                    else {
                        this.maxCounts[input.__jazzCALId] = toInt(input.value);
                    }
                }
                
            }
            else {
            
                //Edit CAL counts mode
                var isValid = true;
                var inputs = this.EditCALTable.getElementsByTagName("input");
                for (var i = 0; i < inputs.length; i++) {
                    if (inputs[i].disabled) {
                        continue;
                    }
                    var result = validateCALInput(inputs[i]);
                    if (!result.valid) {
                        errors = [this.messages.purchaseCountError];
                    }
                }
            }
            
            return errors;
        },
        
        validateServerLicense: function(){
            var errors = [];
            if (this.licenseInfo.serverLicense && this.licenseInfo.serverLicense.disabledReason) {
                errors = [this.messages.serverLicenseError];
            }
            return errors;
        },
        
        //
        // General UI code
        //
        
        //
        // Validation logic and UI - validation can be triggered in two ways:
        // 1) User uploads a file (cbUpload calls fetchToBeState)
        // 2) User enters a new purchased count for a CAL (onPurchasedCountKeyUp)
        //
        
        fetchToBeState: function(){
            var args = dojo.mixin(this.getEditorData(), {
                commit: false
            });
            postLicenseInfo(new SRH(this, "cbFetchToBeState", "cbRemoteError"), args);
        },
        
        cbFetchToBeState: function(licenseInfo){
        
            this.header.clearMessages();
            this.licenseInfo = licenseInfo;
            var type = this.lastUploadType.keyType;
            this.showUploadPreview();
            if (type == "CAL") {
                //Display "Step 1" to update purchase counts
                this.updatePurchaseCounts();
            }
            if (type == "CAL" && this.lastUploadType.policy.floating == true) {
                //Also, Display "Step 2" to offer admin to connect to own server
                this.connectToMyself();
            }
            
            this.validate();
            if (licenseInfo.floatingLicenseTypes && licenseInfo.floatingLicenseTypes.length != this.lastFloatingCount) {
                if (this.lastFloatingCount === 0) {
                    this.setPreviewMessage(this.messages.convertToFloatingWarning, "previewMessage");
                }
            }
            
        },
        
        setPreviewMessage: function(message, className){
            this.previewMessageBox.innerHTML = message;
            this.previewMessageBox.className = className ? className : "";
        },
        
        /**
         * Returns the current data associated with the editor needed to call
         * <code>postLicenseInfo()</code>.
         */
        getEditorData: function(){
            var calFiles = [];
            var self = this;
			
          	for (var key in this._uploadedCALFiles) {
                calFiles.push(this._uploadedCALFiles[key]);
            }

            var args = {
                serverFile: null,
                calFiles: calFiles,
                maxCounts: [],
                operationIds: [FLOATING_SUPPORT_OPERATION_ID]
            };
            
            // if this is not a trial, possibly update the purchased counts
            if (this.mode != "upload") {
                var inputs = this.EditCALTable.getElementsByTagName("input");
                dojo.forEach(inputs, function(input){
                    if (!input.disabled) {
                        args.maxCounts.push({
                            id: input.__jazzCALId,
                            max: toInt(input.value)
                        });
                    }
                });
            }
            else {
                //Need to restructure the maxCount array before sending it back
                for (var key in this.maxCounts) {
                    args.maxCounts.push({
                        id: key,
                        max: this.maxCounts[key]
                    });
                }
            }
            return args;
        },
        
        //
        // UI state manipulation methods
        //
        
        markDirtyLicenseInfo: function(){
            this.isDirtyLicenseInfo = true;
            this.checkDirty();
        },
        
        checkDirty: function(){
            var dirty = false;
            if (this.isDirtyLicenseInfo) {
                dirty = true;
            }
            this._isDirty = dirty;
        },
        
        clearDirty: function(){
            this._isDirty = false;
        },
        
        updateConfigState: function(){
            this.checkDirty();
            this.validate();
        },
        updateNextButton: function(){
            return this._isDirty && this.status.errors.length <= 0;
            
        },
        canFlipToNextPage: function(){
            return this.updateNextButton();
        },
        canFinish: function(){
            return (this._isDirty || this.hasDefaultChanged()) && (!this.status || this.status.errors.length <= 0);
        }
        
    });
    var NUM_REGEX = /[0-9]+/g;
    var d = document;
    d.ce = document.createElement;
    
    function toInt(text){
        var match = text.match(NUM_REGEX);
        return match && parseInt(text, 10);
    }
    function validateCALInput(input){
        //Prevents values like "1a7" from being valid...
        var onlyNum = new RegExp(/^\s*\d+\s*$/);
        var numVal = toInt(input.value);
        if (numVal !== null && numVal <= input.__jazzMaxPurchasable && numVal >= 0 && String(input.value).search(onlyNum) != -1) {
            isValid = true;
            input.__jazzMsgArea.innerHTML = "";
        }
        else {
            var isValid = false;
            var invalidMsg = dojo.string.substitute(messages.invalidCount, [input.__jazzMaxPurchasable]);
            input.__jazzMsgArea.innerHTML = invalidMsg;
        }
        var node = input;
        node.className = isValid ? "num inputCol" : "inputCol";
        
        if (isValid) {
            dojo.removeClass(node, "hasError");
            dojo.removeClass(input.__jazzMsgArea, "errorMsg");
            
            var node = dojo.byId("total-" + input.__jazzCALId);
            var step1Total = dojo.byId("step1-total");
            if (node) {
                //highlightNode(node);
                node.innerHTML = step1Total.innerHTML = numVal + input.__jazzIncluded;
            }
            
        }
        else {
            dojo.addClass(node, "hasError");
            dojo.addClass(input.__jazzMsgArea, "errorMsg");
        }
        
        return {
            changed: input.value !== input.__jazzOrigValue,
            valid: isValid
        };
    }
    function findOperationCheckResults(licenseInfo, operationId){
        var result = null;
        if (licenseInfo.operationCheckResults) {
            dojo.forEach(licenseInfo.operationCheckResults, function(operationResult){
                if (operationResult.operationId == operationId) {
                    result = operationResult.allowed;
                }
            })
        }
        return result;
    }
    
    function getUsedLink(calType){
        if (calType.used === 0) {
            return 0;
        }
        else {
            var a = document.createElement("a");
            a.href = "#action=com.ibm.team.repository.manageUserCALs&licenseType=" + calType.id;
            a.innerHTML = calType.used;
            a.className = "num";
            return a;
        }
    }
    function col(row, node){
        if (node === null || node === undefined) {
            node = "-";
        }
        if (dojo.isString(node) && node.indexOf("null") != -1) {
            node = node.replace("null", "");
        }
        var td = d.ce("td");
        var isNumber = typeof node == 'number' || node instanceof Number;
        var isNumberCol = isNumber || node === messages.notApplicable || node === messages.unlimited;
        if (isNumberCol) {
            td.className = "num";
        }
        if (isNumber) {
            node = dojo.number.format("" + node);
        }
        var isArray = !dojo.isString(node) && dojo.isArrayLike(node);
        if (node.tagName === "A" && node.className === "num") {
            td.className = "num";
        }
        else 
            if (isArray) {
                td.className = "num inputCol";
            }
        row.appendChild(td);
        var nodeArr = isArray ? node : [node];
        dojo.forEach(nodeArr, function(node){
            if (dojo.isString(node)) {
                node = document.createTextNode(node);
            }
            td.appendChild(node);
        });
    }
    function purchasedOrTrialCol(widget, type, isTrial, purchasedOrTrial, isFloatingForm){
    
        var msgDiv = d.ce("div");
        msgDiv.className = "errorMsg";
        
        if (LIC_P.allowsPurchaseCountUpdates(type, isTrial, isFloatingForm)) {
            var elem = d.ce("input");
            elem.value = elem.__jazzOrigValue = "" + purchasedOrTrial;
            if (elem.value == "" && isFloatingForm) 
                elem.value = 0;
            elem.__jazzChgEvt = widget.connect(elem, "onchange", widget.validate);
        }
        else {
            var elem = d.ce("span");
            elem.innerHTML = elem.__jazzOrigValue = "" + purchasedOrTrial;
            if (elem.innerHTML == "" && isFloatingForm) 
                elem.innerHTML = "0";
        }
        elem.id = "inputCalCount";
        elem.className = "num";
        elem.__jazzCALId = type.id;
        // works for all cases except bogus data max a number and free -1, yields max purchase max + 1
        elem.__jazzMaxPurchasable = type.max === -1 ? Infinity : type.max - type.free;
        elem.__jazzIncluded = type.free;
        elem.__jazzMsgArea = msgDiv;
        
        return [elem, msgDiv];
    }
    function getCountOrUnlimited(count){
        return count === -1 ? messages.unlimited : count;
    }
    
    function getCountString(count){
        return count === -1 ? messages.unlimited : (dojo.number.format(count));
    }
    
    
    
})();

